现在的位置: 首页 > 综合 > 正文

组合数学第一发 hdu 2451 Simple Addition Expression

2018年04月24日 ⁄ 综合 ⁄ 共 4510字 ⁄ 字号 评论关闭

hdu 2451 Simple Addition Expression

Problem Description
A luxury yacht with 100 passengers on board is sailing on the sea in the twilight. The yacht is ablaze with lights and there comes out laughers and singing from the hall where an evening party is in full swing. People are singing, dancing and enjoying themselves.

The yacht is equipped with the most advanced navigation and driving system which can all be manipulated by a computer. When the captain notices that there is only gentle breeze and the sea waves are not high, he starts the autopilot. The yacht sails forward
smoothly, ploughs the waves. When it’s completely dark, the passengers start to feel a little funny for sudden forward rushes or sudden decelerations or slight swings. The captain immediately walks to the driving platform and switches the autopilot to human
manipulation. The yacht returns back to normal and the party restarts. Laughers come back, too.

The captain summons the engineer on board to do a thorough check of the navigation system. It turns out that only the computer is out of order, but the exact failure is still unclear. There is a computer scientist among the passengers who is also invited to
the cab to give a hand. He first inputs several groups of data to test the computer. When he inputs 1+2+3, the computer outputs 6, which is exactly right. But when he inputs 4+5+6, the computer outputs 5, which is wrong. Then he inputs 12+13+14, and gets 39,
another right answer, while he inputs 14+15+16, and gets 35, another wrong answer. After the test, the computer scientist says smilingly: “the failure is clear now. The computer's adder can not carry." After excluding the failure, the captain restarts the
autopilot and the yacht returns back to normal, sailing smoothly on the sea.

The captain and the engineer invite the computer scientist to sit down and have a talk. The computer scientist tells a story as following:

A former mathematician defined a kind of simple addition expression. 
If there is an expression (i) + (i+1) + (i+2), i>=0, when carried out additive operations, no position has a carry, it is called simple addition expression.

For instance, when i equals 0, 0+1+2 is a simple addition expression, meanwhile when i equals 11, 11+12+13 is a simple addition expression, too. Because of that no position has a carry.

However, when i equals 3, 3+4+5 is not a simple addition expression, that is because 3+4+5 equals 12, there is a carried number from unit digit to tens digit. In the same way, when i equals 13, 13+14+15 is not a simple addition expression, either. However,
when i equals 112, 112+113+114 is a simple addition expression. Because 112+113+114 equals 339, there is no carry in the process of adding.

when the students have got the definition of simple addition expression, the mathematician puts forward a new question: for a positive integer n, how many simple addition expressions exist when i<n. In addition, i is the first number of a simple addition expression.

when the value of n is large enough, the problem needs to be solved by means of computer.

 


Input
There are several test cases, each case takes up a line, there is an integer n (n<10^10).

 


Output
Output the number of all simple addition expressions when i<n.

 


Sample Input
1 2 3 4 10 11
 


Sample Output
1 2 3 3 3 4
 


Source
 


Recommend
gaojie
 
题意:给出任意N,求从0~N-1这N个数中找出 N+(N+1)+(N+2)时不发生进位的数的总个数。翻译过来就是个位数为0,1,2,非个位数可以为0,1,2,3且小于N的数有多少个。
这题开始时候感觉是数位dp,是有一种可取状态共两种状态的基础数位dp题,也搞了一发过了。
代码
#include<iostream>
#include<cstdio>
#include<cstring>
#include<cmath>
#include<map>
#include<queue>
#include<stack>
#include<vector>
#include<ctype.h>
#include<algorithm>
#include<string>
#define PI acos(-1.0)
#define maxn 15
#define INF 1<<25
typedef long long ll;
using namespace std;
int len;
int nn[maxn];
int ans[maxn];
__int64 dfs(int pos,bool cmp)
{
    if(pos==0)
    return 1;
    if(ans[pos]!=-1&&!cmp)
    return ans[pos];
    int news=(cmp==1?nn[pos]:9);
    if(pos==1)
    news=min(news,2);
    else news=min(news,3);
    __int64 aa=0;
    for(int i=0;i<=news;i++)
    {
        bool c=(cmp&&(i==nn[pos]));
        aa+=dfs(pos-1,c);
    }
    return cmp?aa:ans[pos]=aa;
}
int main()
{
    __int64 num;
        while(scanf("%I64d",&num)!=EOF)
        {
            num--;
            memset(ans,-1,sizeof(ans));
            int pp=0;
            while(num)
            {
                nn[++pp]=num%10;
                num/=10;
            }
            printf("%I64d\n",dfs(pp,1));
        }
}
因为是数论专题里的题,所以还是要用组合数学的想法去思考,从给的数字的最高位往下搞,刚开始不是很理解"组合"是什么意思。
给出“组合数学”定义
狭义的组合数学主要研究满足一定条件的组态(也称组合模型)的存在、计数以及构造等方面的问题。 组合数学的主要内容有组合计数、组合设计、组合矩阵、组合优化(最佳组合)等。
这题的组合数学就是组合的问题。刚开始想要从高位向低位一位一位搞,每搞一位算出后面对应所有可取的数后向后跳一位,直到最后一位。
后来发现自己逗了,如果有某位数(最后一位除外)>=4时,即包括后面的所有情况,便需跳出循环,防止计算不应该计算的数。
代码
#include<iostream>
#include<cstdio>
#include<cstring>
#include<cmath>
#include<map>
#include<queue>
#include<stack>
#include<vector>
#include<ctype.h>
#include<algorithm>
#include<string>
#define PI acos(-1.0)
#define maxn 15
#define INF 1<<25
typedef long long ll;
using namespace std;
int main()
{
    __int64 tot;
    char num[15];
    while(scanf("%s",num)!=EOF)
    {
        __int64 ans=0;
        int len=strlen(num);
        for(int i=0; i<len; i++)
        {
            if((len-i-1))
            {
                if(num[i]>='4')
                    {
                        ans+=pow(4.0,len-1-i)*3;
                        break;
                    }
                else ans+=pow(4.0,len-2-i)*3*(num[i]-'0');
            }
            else
            {
                if(num[i]>='3')
                    ans+=3;
                else ans+=num[i]-'0';
            }
        }
        printf("%I64d\n",ans);

    }
}

可能数据相对比较水的缘故,用两种算法提交都是15ms,不过用组合数学的方法明显时间复杂度比较低。

抱歉!评论已关闭.